/**
 * @name ranges-regex
 * @fileoverview Integrate regex operations into Ranges workflow
 * @version 5.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-regex/}
 */

var rangesRegex=(()=>{var F=Object.create;var y=Object.defineProperty;var A=Object.getOwnPropertyDescriptor;var D=Object.getOwnPropertyNames,d=Object.getOwnPropertySymbols,S=Object.getPrototypeOf,h=Object.prototype.hasOwnProperty,H=Object.prototype.propertyIsEnumerable;var m=(e,r,o)=>r in e?y(e,r,{enumerable:!0,configurable:!0,writable:!0,value:o}):e[r]=o,u=(e,r)=>{for(var o in r||(r={}))h.call(r,o)&&m(e,o,r[o]);if(d)for(var o of d(r))H.call(r,o)&&m(e,o,r[o]);return e};var T=e=>y(e,"__esModule",{value:!0});var N=(e,r)=>()=>(r||e((r={exports:{}}).exports,r),r.exports),W=(e,r)=>{for(var o in r)y(e,o,{get:r[o],enumerable:!0})},b=(e,r,o,s)=>{if(r&&typeof r=="object"||typeof r=="function")for(let i of D(r))!h.call(e,i)&&(o||i!=="default")&&y(e,i,{get:()=>r[i],enumerable:!(s=A(r,i))||s.enumerable});return e},M=(e,r)=>b(T(y(e!=null?F(S(e)):{},"default",!r&&e&&e.__esModule?{get:()=>e.default,enumerable:!0}:{value:e,enumerable:!0})),e),J=(e=>(r,o)=>e&&e.get(r)||(o=b(T({}),r,1),e&&e.set(r,o),o))(typeof WeakMap!="undefined"?new WeakMap:0);var O=N((c,p)=>{var q="[object RegExp]",C=typeof global=="object"&&global&&global.Object===Object&&global,v=typeof c=="object"&&c&&!c.nodeType&&c,R=v&&typeof p=="object"&&p&&!p.nodeType&&p,P=R&&R.exports===v,j=P&&C.process,E=function(){try{return j&&j.binding("util")}catch(e){}}(),I=E&&E.isRegExp;function U(e){return function(r){return e(r)}}var G=Object.prototype,V=G.toString;function z(e){return B(e)&&V.call(e)==q}function B(e){var r=typeof e;return!!e&&(r=="object"||r=="function")}var K=I?U(I):z;p.exports=K});var Y={};W(Y,{rRegex:()=>X,version:()=>Q});var k={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function f(e,r){if(!Array.isArray(e)||!e.length)return e;let o=u(u({},k),r),s,i;if(o.strictlyTwoElementsInRangeArrays&&!e.every((a,l)=>!Array.isArray(a)||a.length!==2?(s=l,i=a.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) has not two but ${i} elements!`);if(!e.every((a,l)=>!Array.isArray(a)||!Number.isInteger(a[0])||a[0]<0||!Number.isInteger(a[1])||a[1]<0?(s=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(e[s],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,g=0;return Array.from(e).sort((a,l)=>(o.progressFn&&(g+=1,o.progressFn(Math.floor(g*100/t))),a[0]===l[0]?a[1]<l[1]?-1:a[1]>l[1]?1:0:a[0]<l[0]?-1:1))}var x={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function w(e,r){function o(n){return n&&typeof n=="object"&&!Array.isArray(n)}if(!Array.isArray(e)||!e.length)return null;let s;if(r)if(o(r)){if(s=u(u({},x),r),s.progressFn&&o(s.progressFn)&&!Object.keys(s.progressFn).length)s.progressFn=null;else if(s.progressFn&&typeof s.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof s.progressFn}", equal to ${JSON.stringify(s.progressFn,null,4)}`);if(![1,2,"1","2"].includes(s.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);if(typeof s.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof s.joinRangesThatTouchEdges}", equal to ${JSON.stringify(s.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r,null,4)} (type ${typeof r})`);else s=u({},x);let i=e.filter(n=>Array.isArray(n)).map(n=>[...n]).filter(n=>n[2]!==void 0||n[0]!==n[1]),t,g,a;s.progressFn?t=f(i,{progressFn:n=>{a=Math.floor(n/5),a!==g&&(g=a,s.progressFn(a))}}):t=f(i);let l=t.length-1;for(let n=l;n>0;n--)s.progressFn&&(a=Math.floor((1-n/l)*78)+21,a!==g&&a>g&&(g=a,s.progressFn(a))),(t[n][0]<=t[n-1][0]||!s.joinRangesThatTouchEdges&&t[n][0]<t[n-1][1]||s.joinRangesThatTouchEdges&&t[n][0]<=t[n-1][1])&&(t[n-1][0]=Math.min(t[n][0],t[n-1][0]),t[n-1][1]=Math.max(t[n][1],t[n-1][1]),t[n][2]!==void 0&&(t[n-1][0]>=t[n][0]||t[n-1][1]<=t[n][1])&&t[n-1][2]!==null&&(t[n][2]===null&&t[n-1][2]!==null?t[n-1][2]=null:t[n-1][2]!=null?+s.mergeType==2&&t[n-1][0]===t[n][0]?t[n-1][2]=t[n][2]:t[n-1][2]+=t[n][2]:t[n-1][2]=t[n][2]),t.splice(n,1),n=t.length);return t.length?t:null}var $=M(O(),1);var _="5.0.12";var Q=_;function X(e,r,o){if(e===void 0)throw new TypeError("ranges-regex: [THROW_ID_01] The first input's argument must be a regex object! Currently it is missing!");if(!(0,$.default)(e))throw new TypeError(`ranges-regex: [THROW_ID_02] The first input's argument must be a regex object! Currently its type is: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(typeof r!="string")throw new TypeError(`ranges-regex: [THROW_ID_03] The second input's argument must be a string! Currently its type is: ${typeof r}, equal to: ${JSON.stringify(r,null,4)}`);if(o&&typeof o!="string")throw new TypeError(`ranges-regex: [THROW_ID_04] The third input's argument must be a string or null! Currently its type is: ${typeof o}, equal to: ${JSON.stringify(o,null,4)}`);if(!r.length)return null;let s,i=[];if(o===null||typeof o=="string"&&o.length)for(;(s=e.exec(r))!==null;)i.push([e.lastIndex-s[0].length,e.lastIndex,o]);else for(;(s=e.exec(r))!==null;)i.push([e.lastIndex-s[0].length,e.lastIndex]);return i.length?w(i):null}return J(Y);})();
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 8.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 5.0.12
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
